<template>
  <rui-drawer v-if="patch"
              :overlay="false"
              @close="$emit('close')">
    <template #caption>
      <!-- eslint-disable vue/no-v-html -->
      {{ patch.displayName }} <small v-if="measure" v-html="measure" />
      <!-- eslint-enable vue/no-v-html -->
    </template>

    <template #actions>
      <patch-actions :patch="patch"
                     @add-element="bubbleAddElement" />
    </template>

    <aside class="_container">
      <rui-empty v-if="elements && elements.length === 0" icon-size="3" :content="$t('js.patch.no_element_in_this_patch')" small />
      <gpa-elements-list :elements="elements" context="list" />
    </aside>
  </rui-drawer>
</template>

<script>
import RuiEmpty from '@experiments-labs/rise_ui/src/components/DataDisplay/Empty/Empty.vue'
import RuiDrawer from '@experiments-labs/rise_ui/src/components/Drawer/Drawer.vue'

import Patch from '../../../../classes/models/Patch'
import { formatGeometryMeasure } from '../../../../tools/MeasureFormatters'
import { shapeIcons } from '../../../../shapeIcons'
import PatchActions from './_Actions.vue'
import GpaElementsList from '../Elements/_List.vue'

export default {
  name: 'GpaPatchDrawer',
  emits: [
    'close',
    'add-patch-resource',
  ],
  components: { RuiEmpty, RuiDrawer, GpaElementsList, PatchActions },
  props: {
    patch: { required: false, type: Patch, default: null },
  },
  data () {
    return {
      shapeIcons,
    }
  },
  computed: {
    elements () {
      return this.$store.getters.elementsByPatchId(this.patch.id)
        .filter(c => !c.isRemoved)
    },
    measure () { return formatGeometryMeasure(this.patch) },
    geometryType () { return this.patch.geometryType },
  },
  methods: {
    bubbleAddElement (patch) { this.$emit('add-patch-resource', patch.id) },
  },
}
</script>
